### Hierarchy

- AtomComponent<IAtomElement, AtomXFControl>
  - AtomXFControl

### Implements

- IAtomComponent<IAtomElement>
- INotifyPropertyChanged

## Index

### Constructors

- constructor

### Properties

- app
- data
- defaultControlStyle
- disposables
- element
- localViewModel
- pendingInits
- viewModel
- isControl

### Accessors

- controlStyle
- parent
- theme
- vsProps

### Methods

- append
- atomParent
- beginEdit
- bind
- bindEvent
- create
- dispose
- hasProperty
- invalidate
- invokeEvent
- loadXaml
- onPropertyChanged
- onUpdateUI
- preCreate
- registerDisposable
- render
- resolve
- runAfterInit
- setElementValue
- setLocalValue
- setPrimitiveValue
- staticResource
- unbind
- unbindEvent

## Constructors

### constructor

- new AtomXFControl(app: App, element?: IAtomElement): AtomXFControl

- Inherited from AtomComponent.constructor

  - Defined in src/core/AtomComponent.ts:140

  #### Parameters

  - ##### app: App

  - ##### Default value element: IAtomElement = null

  #### Returns AtomXFControl

## Properties

### app

app: App

Implementation of IAtomComponent.app

Inherited from AtomComponent.app

- Defined in src/core/AtomComponent.ts:143

### data

data: any

Implementation of IAtomComponent.data

Inherited from AtomComponent.data

- Defined in src/core/AtomComponent.ts:51

### defaultControlStyle

defaultControlStyle: any

- Defined in src/xf/controls/AtomXFControl.ts:22

### disposables

disposables: AtomDisposableList

Inherited from AtomComponent.disposables

- Defined in src/core/AtomComponent.ts:46

### element

element: IAtomElement

Implementation of IAtomComponent.element

Inherited from AtomComponent.element

- Defined in src/core/AtomComponent.ts:48

### localViewModel

localViewModel: any

Implementation of IAtomComponent.localViewModel

Inherited from AtomComponent.localViewModel

- Defined in src/core/AtomComponent.ts:57

### Protected pendingInits

pendingInits: Array<function>

Inherited from AtomComponent.pendingInits

- Defined in src/core/AtomComponent.ts:59

### viewModel

viewModel: any

Implementation of IAtomComponent.viewModel

Inherited from AtomComponent.viewModel

- Defined in src/core/AtomComponent.ts:54

### Static isControl

isControl: true = true

Inherited from AtomComponent.isControl

- Defined in src/core/AtomComponent.ts:43

## Accessors

### controlStyle

- get controlStyle(): AtomStyle
- set controlStyle(v: AtomStyle): void

- - Defined in src/xf/controls/AtomXFControl.ts:25

  #### Returns AtomStyle

- - Defined in src/xf/controls/AtomXFControl.ts:43

  #### Parameters

  - ##### v: AtomStyle

  #### Returns void

### parent

- get parent(): AtomXFControl

- Overrides AtomComponent.parent

  - Defined in src/xf/controls/AtomXFControl.ts:61

  #### Returns AtomXFControl

### theme

- get theme(): AtomStyleSheet

- - Defined in src/xf/controls/AtomXFControl.ts:55

  #### Returns AtomStyleSheet

### vsProps

- get vsProps(): object | object | __type

- Inherited from AtomComponent.vsProps

  - Defined in src/core/AtomComponent.ts:129

  Do not ever use, only available as intellisense feature for vs code editor.

  #### Returns object | object | __type

## Methods

### append

- append(element: any): AtomXFControl

- Overrides AtomComponent.append

  - Defined in src/xf/controls/AtomXFControl.ts:72

  #### Parameters

  - ##### element: any

  #### Returns AtomXFControl

### atomParent

- atomParent(e: IAtomElement): AtomXFControl

- Overrides AtomComponent.atomParent

  - Defined in src/xf/controls/AtomXFControl.ts:68

  #### Parameters

  - ##### e: IAtomElement

  #### Returns AtomXFControl

### beginEdit

- beginEdit(): IDisposable

- Inherited from AtomComponent.beginEdit

  - Defined in src/core/AtomComponent.ts:396

  #### Returns IDisposable

### bind

- bind(element: IAtomElement, name: string, path: PathList[], twoWays?: boolean | string[], valueFunc?: function, source?: any): IDisposable

- Inherited from AtomComponent.bind

  - Defined in src/core/AtomComponent.ts:158

  #### Parameters

  - ##### element: IAtomElement

  - ##### name: string

  - ##### path: PathList[]

  - ##### Optional twoWays: boolean | string[]

  - ##### Optional valueFunc: function

    - - (...v: any[]): any

      - #### Parameters

        - ##### Rest ...v: any[]

        #### Returns any

  - ##### Optional source: any

  #### Returns IDisposable

### bindEvent

- bindEvent(element: IAtomElement, name?: string, method?: EventListenerOrEventListenerObject, key?: string): IDisposable

- Inherited from AtomComponent.bindEvent

  - Defined in src/core/AtomComponent.ts:196

  #### Parameters

  - ##### element: IAtomElement

  - ##### Optional name: string

  - ##### Optional method: EventListenerOrEventListenerObject

  - ##### Optional key: string

  #### Returns IDisposable

### Protected create

- create(): void

- Inherited from AtomComponent.create

  - Defined in src/core/AtomComponent.ts:523

  #### Returns void

### dispose

- dispose(e?: IAtomElement): void

- Overrides AtomComponent.dispose

  - Defined in src/xf/controls/AtomXFControl.ts:77

  #### Parameters

  - ##### Optional e: IAtomElement

  #### Returns void

### hasProperty

- hasProperty(name: string): boolean

- Implementation of IAtomComponent.hasProperty

  Inherited from AtomComponent.hasProperty

  - Defined in src/core/AtomComponent.ts:264

  Control checks if property is declared on the control or not. Since TypeScript no longer creates enumerable properties, we have to inspect name and PropertyMap which is generated by `@BindableProperty` or the value is not set to undefined.

  #### Parameters

  - ##### name: string

    name of Property

  #### Returns boolean

### invalidate

- invalidate(): void

- Inherited from AtomComponent.invalidate

  - Defined in src/core/AtomComponent.ts:416

  #### Returns void

### invokeEvent

- invokeEvent(event: object): void

- - Defined in src/xf/controls/AtomXFControl.ts:83

  #### Parameters

  - ##### event: object

  #### Returns void

### loadXaml

- loadXaml(text: string): void

- - Defined in src/xf/controls/AtomXFControl.ts:91

  #### Parameters

  - ##### text: string

  #### Returns void

### onPropertyChanged

- onPropertyChanged(name: string): void

- Implementation of INotifyPropertyChanged.onPropertyChanged

  Inherited from AtomComponent.onPropertyChanged

  - Defined in src/core/AtomComponent.ts:392

  #### Parameters

  - ##### name: string

  #### Returns void

### onUpdateUI

- onUpdateUI(): void

- Inherited from AtomComponent.onUpdateUI

  - Defined in src/core/AtomComponent.ts:428

  #### Returns void

### Protected preCreate

- preCreate(): void

- Inherited from AtomComponent.preCreate

  - Defined in src/core/AtomComponent.ts:527

  #### Returns void

### registerDisposable

- registerDisposable(d: IDisposable): IDisposable

- Inherited from AtomComponent.registerDisposable

  - Defined in src/core/AtomComponent.ts:440

  #### Parameters

  - ##### d: IDisposable

  #### Returns IDisposable

### Protected render

- render(node: XNode, e?: any, creator?: any): void

- Inherited from AtomComponent.render

  - Defined in src/core/AtomComponent.ts:444

  #### Parameters

  - ##### node: XNode

  - ##### Optional e: any

  - ##### Optional creator: any

  #### Returns void

### Protected resolve

- resolve<TService>(c: TService, selfName?: string | function): IAnyInstanceType<TService>

- Inherited from AtomComponent.resolve

  - Defined in src/core/AtomComponent.ts:535

  #### Type parameters

  - #### TService

  #### Parameters

  - ##### c: TService

  - ##### Optional selfName: string | function

  #### Returns IAnyInstanceType<TService>

### runAfterInit

- runAfterInit(f: function): void

- Inherited from AtomComponent.runAfterInit

  - Defined in src/core/AtomComponent.ts:432

  #### Parameters

  - ##### f: function

    - - (): void

      - #### Returns void

### Protected setElementValue

- setElementValue(element: any, name: string, value: any): void

- Overrides AtomComponent.setElementValue

  - Defined in src/xf/controls/AtomXFControl.ts:95

  #### Parameters

  - ##### element: any

  - ##### name: string

  - ##### value: any

  #### Returns void

### setLocalValue

- setLocalValue(element: IAtomElement, name: string, value: any): void

- Inherited from AtomComponent.setLocalValue

  - Defined in src/core/AtomComponent.ts:316

  #### Parameters

  - ##### element: IAtomElement

  - ##### name: string

  - ##### value: any

  #### Returns void

### setPrimitiveValue

- setPrimitiveValue(element: IAtomElement, name: string, value: any): void

- Inherited from AtomComponent.setPrimitiveValue

  - Defined in src/core/AtomComponent.ts:281

  Use this method if you want to set attribute on HTMLElement immediately but defer atom control property

  #### Parameters

  - ##### element: IAtomElement

    HTMLElement

  - ##### name: string

    string

  - ##### value: any

    any

  #### Returns void

### staticResource

- staticResource(name: string): any

- - Defined in src/xf/controls/AtomXFControl.ts:87

  #### Parameters

  - ##### name: string

  #### Returns any

### unbind

- unbind(element: IAtomElement, name?: string): void

- Inherited from AtomComponent.unbind

  - Defined in src/core/AtomComponent.ts:188

  Remove all bindings associated with given element and optional name

  #### Parameters

  - ##### element: IAtomElement

    T

  - ##### Optional name: string

    string

  #### Returns void

### unbindEvent

- unbindEvent(element: IAtomElement, name?: string, method?: EventListenerOrEventListenerObject, key?: string): void

- Inherited from AtomComponent.unbindEvent

  - Defined in src/core/AtomComponent.ts:226

  #### Parameters

  - ##### element: IAtomElement

  - ##### Optional name: string

  - ##### Optional method: EventListenerOrEventListenerObject

  - ##### Optional key: string

  #### Returns void

Generated using TypeDoc